<?php
/**
 * StocksApi
 * PHP version 7.4
 *
 * @category Class
 * @package  PrestaShop\Module\PolarisPrestaConnector\pol\api\lib
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Polaris WebConnect
 *
 * L'API WebConnect vous permet d'interconnecter facilement votre solution Polaris avec un site Internet en permettant à ce dernier de télécharger votre catalogue, vos clients, votre fidélité       *Pour rappel, la spécification OpenAPI est une spécification de fichiers d'interface lisibles par une machine pour décrire, produire, consommer et visualiser les services Web REST de manière automatisée. Vous pouvez donc utiliser des outils comme [Swagger](https://editor.swagger.io/) pour générer automatiquement une bibliothèque cliente dans le langage de votre choix.*    **Voir la documentation générale : [https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect)**
 *
 * The version of the OpenAPI document: 13.1.99.65534
 * Contact: assistance@vega-info.fr
 * Generated by: https://openapi-generator.tech
 * Generator version: 7.8.0
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Configuration;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\HeaderSelector;
use PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ObjectSerializer;

/**
 * StocksApi Class Doc Comment
 *
 * @category Class
 * @package  PrestaShop\Module\PolarisPrestaConnector\pol\api\lib
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class StocksApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /** @var string[] $contentTypes **/
    public const contentTypes = [
        'stocksGetCommandes' => [
            'application/json',
        ],
        'stocksGetDetailsPromotions' => [
            'application/json',
        ],
        'stocksGetPromotions' => [
            'application/json',
        ],
        'stocksGetStocks' => [
            'application/json',
        ],
        'stocksGetTransfert' => [
            'application/json',
        ],
        'stocksGetVenteEnGros' => [
            'application/json',
        ],
        'stocksPostConfirmationTransfert' => [
            'application/json',
        ],
        'stocksPostTransfert' => [
            'application/json',
        ],
        'stocksPostVenteEnGros' => [
            'application/json',
        ],
    ];

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation stocksGetCommandes
     *
     * Obtient les commandes en cours. ATTENTION : les données de L&#39;API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n&#39;est plus en commande les données n&#39;existent pas dans le JSON de retour
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetCommandes'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde
     */
    public function stocksGetCommandes($filtre_produit = null, $derniere_modification = null, $pager = null, string $contentType = self::contentTypes['stocksGetCommandes'][0])
    {
        list($response) = $this->stocksGetCommandesWithHttpInfo($filtre_produit, $derniere_modification, $pager, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetCommandesWithHttpInfo
     *
     * Obtient les commandes en cours. ATTENTION : les données de L&#39;API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n&#39;est plus en commande les données n&#39;existent pas dans le JSON de retour
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetCommandes'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetCommandesWithHttpInfo($filtre_produit = null, $derniere_modification = null, $pager = null, string $contentType = self::contentTypes['stocksGetCommandes'][0])
    {
        $request = $this->stocksGetCommandesRequest($filtre_produit, $derniere_modification, $pager, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetCommandesAsync
     *
     * Obtient les commandes en cours. ATTENTION : les données de L&#39;API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n&#39;est plus en commande les données n&#39;existent pas dans le JSON de retour
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetCommandes'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetCommandesAsync($filtre_produit = null, $derniere_modification = null, $pager = null, string $contentType = self::contentTypes['stocksGetCommandes'][0])
    {
        return $this->stocksGetCommandesAsyncWithHttpInfo($filtre_produit, $derniere_modification, $pager, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetCommandesAsyncWithHttpInfo
     *
     * Obtient les commandes en cours. ATTENTION : les données de L&#39;API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n&#39;est plus en commande les données n&#39;existent pas dans le JSON de retour
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetCommandes'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetCommandesAsyncWithHttpInfo($filtre_produit = null, $derniere_modification = null, $pager = null, string $contentType = self::contentTypes['stocksGetCommandes'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveCde';
        $request = $this->stocksGetCommandesRequest($filtre_produit, $derniere_modification, $pager, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetCommandes'
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetCommandes'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetCommandesRequest($filtre_produit = null, $derniere_modification = null, $pager = null, string $contentType = self::contentTypes['stocksGetCommandes'][0])
    {





        $resourcePath = '/Stocks/Commandes';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $filtre_produit,
            'filtreProduit', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $derniere_modification,
            'derniereModification', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $pager,
            'pager', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksGetDetailsPromotions
     *
     * Obtient les détails des plans de promotions.
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les détails ayant changés depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  string $code_promotion Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code (optional)
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetDetailsPromotions'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion
     */
    public function stocksGetDetailsPromotions($derniere_modification = null, $only_active = true, $code_promotion = null, $filtre_produit = null, $pager = null, string $contentType = self::contentTypes['stocksGetDetailsPromotions'][0])
    {
        list($response) = $this->stocksGetDetailsPromotionsWithHttpInfo($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetDetailsPromotionsWithHttpInfo
     *
     * Obtient les détails des plans de promotions.
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les détails ayant changés depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  string $code_promotion Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code (optional)
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetDetailsPromotions'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetDetailsPromotionsWithHttpInfo($derniere_modification = null, $only_active = true, $code_promotion = null, $filtre_produit = null, $pager = null, string $contentType = self::contentTypes['stocksGetDetailsPromotions'][0])
    {
        $request = $this->stocksGetDetailsPromotionsRequest($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetDetailsPromotionsAsync
     *
     * Obtient les détails des plans de promotions.
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les détails ayant changés depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  string $code_promotion Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code (optional)
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetDetailsPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetDetailsPromotionsAsync($derniere_modification = null, $only_active = true, $code_promotion = null, $filtre_produit = null, $pager = null, string $contentType = self::contentTypes['stocksGetDetailsPromotions'][0])
    {
        return $this->stocksGetDetailsPromotionsAsyncWithHttpInfo($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetDetailsPromotionsAsyncWithHttpInfo
     *
     * Obtient les détails des plans de promotions.
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les détails ayant changés depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  string $code_promotion Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code (optional)
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetDetailsPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetDetailsPromotionsAsyncWithHttpInfo($derniere_modification = null, $only_active = true, $code_promotion = null, $filtre_produit = null, $pager = null, string $contentType = self::contentTypes['stocksGetDetailsPromotions'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion';
        $request = $this->stocksGetDetailsPromotionsRequest($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetDetailsPromotions'
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les détails ayant changés depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  string $code_promotion Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code (optional)
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetDetailsPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetDetailsPromotionsRequest($derniere_modification = null, $only_active = true, $code_promotion = null, $filtre_produit = null, $pager = null, string $contentType = self::contentTypes['stocksGetDetailsPromotions'][0])
    {







        $resourcePath = '/Stocks/DetailsPromotions';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $derniere_modification,
            'derniereModification', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $only_active,
            'onlyActive', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $code_promotion,
            'codePromotion', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $filtre_produit,
            'filtreProduit', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $pager,
            'pager', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksGetPromotions
     *
     * Obtient les promotions en cours et à venir
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les promotions ayant changées depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetPromotions'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion
     */
    public function stocksGetPromotions($derniere_modification = null, $only_active = true, $pager = null, string $contentType = self::contentTypes['stocksGetPromotions'][0])
    {
        list($response) = $this->stocksGetPromotionsWithHttpInfo($derniere_modification, $only_active, $pager, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetPromotionsWithHttpInfo
     *
     * Obtient les promotions en cours et à venir
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les promotions ayant changées depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetPromotions'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetPromotionsWithHttpInfo($derniere_modification = null, $only_active = true, $pager = null, string $contentType = self::contentTypes['stocksGetPromotions'][0])
    {
        $request = $this->stocksGetPromotionsRequest($derniere_modification, $only_active, $pager, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetPromotionsAsync
     *
     * Obtient les promotions en cours et à venir
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les promotions ayant changées depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetPromotionsAsync($derniere_modification = null, $only_active = true, $pager = null, string $contentType = self::contentTypes['stocksGetPromotions'][0])
    {
        return $this->stocksGetPromotionsAsyncWithHttpInfo($derniere_modification, $only_active, $pager, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetPromotionsAsyncWithHttpInfo
     *
     * Obtient les promotions en cours et à venir
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les promotions ayant changées depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetPromotionsAsyncWithHttpInfo($derniere_modification = null, $only_active = true, $pager = null, string $contentType = self::contentTypes['stocksGetPromotions'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultPromotion';
        $request = $this->stocksGetPromotionsRequest($derniere_modification, $only_active, $pager, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetPromotions'
     *
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que les promotions ayant changées depuis cette date (optional)
     * @param  bool $only_active Si vrai, ne renvoi que les promotions en cours et futures (optional, default to true)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetPromotions'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetPromotionsRequest($derniere_modification = null, $only_active = true, $pager = null, string $contentType = self::contentTypes['stocksGetPromotions'][0])
    {





        $resourcePath = '/Stocks/Promotions';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $derniere_modification,
            'derniereModification', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $only_active,
            'onlyActive', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $pager,
            'pager', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksGetStocks
     *
     * Obtient les changements de stocks et de prix.
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  \DateTime $date_solde Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé (optional)
     * @param  bool $is_solde Le plan est en plan de solde (optional, default to true)
     * @param  bool $is_promo Le plan est en plan de promotions (optional, default to true)
     * @param  bool $is_internet Le plan est valable sur internet (optional, default to true)
     * @param  bool $is_magasin Le plan est valable en boutique (optional, default to true)
     * @param  string $code_promo Code du plan (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetStocks'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock
     */
    public function stocksGetStocks($filtre_produit = null, $derniere_modification = null, $pager = null, $date_solde = null, $is_solde = true, $is_promo = true, $is_internet = true, $is_magasin = true, $code_promo = null, string $contentType = self::contentTypes['stocksGetStocks'][0])
    {
        list($response) = $this->stocksGetStocksWithHttpInfo($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetStocksWithHttpInfo
     *
     * Obtient les changements de stocks et de prix.
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  \DateTime $date_solde Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé (optional)
     * @param  bool $is_solde Le plan est en plan de solde (optional, default to true)
     * @param  bool $is_promo Le plan est en plan de promotions (optional, default to true)
     * @param  bool $is_internet Le plan est valable sur internet (optional, default to true)
     * @param  bool $is_magasin Le plan est valable en boutique (optional, default to true)
     * @param  string $code_promo Code du plan (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetStocks'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetStocksWithHttpInfo($filtre_produit = null, $derniere_modification = null, $pager = null, $date_solde = null, $is_solde = true, $is_promo = true, $is_internet = true, $is_magasin = true, $code_promo = null, string $contentType = self::contentTypes['stocksGetStocks'][0])
    {
        $request = $this->stocksGetStocksRequest($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetStocksAsync
     *
     * Obtient les changements de stocks et de prix.
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  \DateTime $date_solde Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé (optional)
     * @param  bool $is_solde Le plan est en plan de solde (optional, default to true)
     * @param  bool $is_promo Le plan est en plan de promotions (optional, default to true)
     * @param  bool $is_internet Le plan est valable sur internet (optional, default to true)
     * @param  bool $is_magasin Le plan est valable en boutique (optional, default to true)
     * @param  string $code_promo Code du plan (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetStocks'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetStocksAsync($filtre_produit = null, $derniere_modification = null, $pager = null, $date_solde = null, $is_solde = true, $is_promo = true, $is_internet = true, $is_magasin = true, $code_promo = null, string $contentType = self::contentTypes['stocksGetStocks'][0])
    {
        return $this->stocksGetStocksAsyncWithHttpInfo($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetStocksAsyncWithHttpInfo
     *
     * Obtient les changements de stocks et de prix.
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  \DateTime $date_solde Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé (optional)
     * @param  bool $is_solde Le plan est en plan de solde (optional, default to true)
     * @param  bool $is_promo Le plan est en plan de promotions (optional, default to true)
     * @param  bool $is_internet Le plan est valable sur internet (optional, default to true)
     * @param  bool $is_magasin Le plan est valable en boutique (optional, default to true)
     * @param  string $code_promo Code du plan (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetStocks'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetStocksAsyncWithHttpInfo($filtre_produit = null, $derniere_modification = null, $pager = null, $date_solde = null, $is_solde = true, $is_promo = true, $is_internet = true, $is_magasin = true, $code_promo = null, string $contentType = self::contentTypes['stocksGetStocks'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\PagedResultReleveStock';
        $request = $this->stocksGetStocksRequest($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetStocks'
     *
     * @param  FiltreProduit $filtre_produit Si précisé, ne renvoi que les articles des produits correspondants au filtrage (optional)
     * @param  \DateTime $derniere_modification Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée (optional)
     * @param  Pager $pager Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) (optional)
     * @param  \DateTime $date_solde Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé (optional)
     * @param  bool $is_solde Le plan est en plan de solde (optional, default to true)
     * @param  bool $is_promo Le plan est en plan de promotions (optional, default to true)
     * @param  bool $is_internet Le plan est valable sur internet (optional, default to true)
     * @param  bool $is_magasin Le plan est valable en boutique (optional, default to true)
     * @param  string $code_promo Code du plan (optional)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetStocks'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetStocksRequest($filtre_produit = null, $derniere_modification = null, $pager = null, $date_solde = null, $is_solde = true, $is_promo = true, $is_internet = true, $is_magasin = true, $code_promo = null, string $contentType = self::contentTypes['stocksGetStocks'][0])
    {











        $resourcePath = '/Stocks/Stocks';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $filtre_produit,
            'filtreProduit', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $derniere_modification,
            'derniereModification', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $pager,
            'pager', // param base name
            '', // openApiType
            '', // style
            false, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $date_solde,
            'dateSolde', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $is_solde,
            'isSolde', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $is_promo,
            'isPromo', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $is_internet,
            'isInternet', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $is_magasin,
            'isMagasin', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $code_promo,
            'codePromo', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksGetTransfert
     *
     * Contrôler un mouvement de stock
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert
     */
    public function stocksGetTransfert($ref_transfert, string $contentType = self::contentTypes['stocksGetTransfert'][0])
    {
        list($response) = $this->stocksGetTransfertWithHttpInfo($ref_transfert, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetTransfertWithHttpInfo
     *
     * Contrôler un mouvement de stock
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetTransfertWithHttpInfo($ref_transfert, string $contentType = self::contentTypes['stocksGetTransfert'][0])
    {
        $request = $this->stocksGetTransfertRequest($ref_transfert, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetTransfertAsync
     *
     * Contrôler un mouvement de stock
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetTransfertAsync($ref_transfert, string $contentType = self::contentTypes['stocksGetTransfert'][0])
    {
        return $this->stocksGetTransfertAsyncWithHttpInfo($ref_transfert, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetTransfertAsyncWithHttpInfo
     *
     * Contrôler un mouvement de stock
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetTransfertAsyncWithHttpInfo($ref_transfert, string $contentType = self::contentTypes['stocksGetTransfert'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert';
        $request = $this->stocksGetTransfertRequest($ref_transfert, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetTransfert'
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetTransfertRequest($ref_transfert, string $contentType = self::contentTypes['stocksGetTransfert'][0])
    {

        // verify the required parameter 'ref_transfert' is set
        if ($ref_transfert === null || (is_array($ref_transfert) && count($ref_transfert) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $ref_transfert when calling stocksGetTransfert'
            );
        }


        $resourcePath = '/Stocks/Transfert';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $ref_transfert,
            'refTransfert', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksGetVenteEnGros
     *
     * Contrôler une vente en gros
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetVenteEnGros'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros
     */
    public function stocksGetVenteEnGros($ref_transfert, string $contentType = self::contentTypes['stocksGetVenteEnGros'][0])
    {
        list($response) = $this->stocksGetVenteEnGrosWithHttpInfo($ref_transfert, $contentType);
        return $response;
    }

    /**
     * Operation stocksGetVenteEnGrosWithHttpInfo
     *
     * Contrôler une vente en gros
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetVenteEnGros'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksGetVenteEnGrosWithHttpInfo($ref_transfert, string $contentType = self::contentTypes['stocksGetVenteEnGros'][0])
    {
        $request = $this->stocksGetVenteEnGrosRequest($ref_transfert, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksGetVenteEnGrosAsync
     *
     * Contrôler une vente en gros
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetVenteEnGrosAsync($ref_transfert, string $contentType = self::contentTypes['stocksGetVenteEnGros'][0])
    {
        return $this->stocksGetVenteEnGrosAsyncWithHttpInfo($ref_transfert, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksGetVenteEnGrosAsyncWithHttpInfo
     *
     * Contrôler une vente en gros
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksGetVenteEnGrosAsyncWithHttpInfo($ref_transfert, string $contentType = self::contentTypes['stocksGetVenteEnGros'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros';
        $request = $this->stocksGetVenteEnGrosRequest($ref_transfert, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksGetVenteEnGros'
     *
     * @param  string $ref_transfert Référence unique du transfert (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksGetVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksGetVenteEnGrosRequest($ref_transfert, string $contentType = self::contentTypes['stocksGetVenteEnGros'][0])
    {

        // verify the required parameter 'ref_transfert' is set
        if ($ref_transfert === null || (is_array($ref_transfert) && count($ref_transfert) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $ref_transfert when calling stocksGetVenteEnGros'
            );
        }


        $resourcePath = '/Stocks/VenteEnGros';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $ref_transfert,
            'refTransfert', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksPostConfirmationTransfert
     *
     * Indique la confirmation d&#39;un transfert ou d&#39;une commande interne
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation $metier_mvt_web_connect_confirmation_transfert_creation Description de la confirmation de transfert de marchandise  (transfert) (required)
     * @param  bool $terminer_transfert Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées (optional, default to true)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostConfirmationTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse
     */
    public function stocksPostConfirmationTransfert($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert = true, string $contentType = self::contentTypes['stocksPostConfirmationTransfert'][0])
    {
        list($response) = $this->stocksPostConfirmationTransfertWithHttpInfo($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert, $contentType);
        return $response;
    }

    /**
     * Operation stocksPostConfirmationTransfertWithHttpInfo
     *
     * Indique la confirmation d&#39;un transfert ou d&#39;une commande interne
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation $metier_mvt_web_connect_confirmation_transfert_creation Description de la confirmation de transfert de marchandise  (transfert) (required)
     * @param  bool $terminer_transfert Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées (optional, default to true)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostConfirmationTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksPostConfirmationTransfertWithHttpInfo($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert = true, string $contentType = self::contentTypes['stocksPostConfirmationTransfert'][0])
    {
        $request = $this->stocksPostConfirmationTransfertRequest($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksPostConfirmationTransfertAsync
     *
     * Indique la confirmation d&#39;un transfert ou d&#39;une commande interne
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation $metier_mvt_web_connect_confirmation_transfert_creation Description de la confirmation de transfert de marchandise  (transfert) (required)
     * @param  bool $terminer_transfert Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées (optional, default to true)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostConfirmationTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostConfirmationTransfertAsync($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert = true, string $contentType = self::contentTypes['stocksPostConfirmationTransfert'][0])
    {
        return $this->stocksPostConfirmationTransfertAsyncWithHttpInfo($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksPostConfirmationTransfertAsyncWithHttpInfo
     *
     * Indique la confirmation d&#39;un transfert ou d&#39;une commande interne
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation $metier_mvt_web_connect_confirmation_transfert_creation Description de la confirmation de transfert de marchandise  (transfert) (required)
     * @param  bool $terminer_transfert Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées (optional, default to true)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostConfirmationTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostConfirmationTransfertAsyncWithHttpInfo($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert = true, string $contentType = self::contentTypes['stocksPostConfirmationTransfert'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse';
        $request = $this->stocksPostConfirmationTransfertRequest($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksPostConfirmationTransfert'
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation $metier_mvt_web_connect_confirmation_transfert_creation Description de la confirmation de transfert de marchandise  (transfert) (required)
     * @param  bool $terminer_transfert Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées (optional, default to true)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostConfirmationTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksPostConfirmationTransfertRequest($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert = true, string $contentType = self::contentTypes['stocksPostConfirmationTransfert'][0])
    {

        // verify the required parameter 'metier_mvt_web_connect_confirmation_transfert_creation' is set
        if ($metier_mvt_web_connect_confirmation_transfert_creation === null || (is_array($metier_mvt_web_connect_confirmation_transfert_creation) && count($metier_mvt_web_connect_confirmation_transfert_creation) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $metier_mvt_web_connect_confirmation_transfert_creation when calling stocksPostConfirmationTransfert'
            );
        }



        $resourcePath = '/Stocks/ConfirmationTransfert';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $terminer_transfert,
            'terminerTransfert', // param base name
            'boolean', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);




        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($metier_mvt_web_connect_confirmation_transfert_creation)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($metier_mvt_web_connect_confirmation_transfert_creation));
            } else {
                $httpBody = $metier_mvt_web_connect_confirmation_transfert_creation;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksPostTransfert
     *
     * Créer un mouvement de stock en deux magasins
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation $metier_mvt_web_connect_transfert_creation Description du transfert de marchandise  (transfert) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert
     */
    public function stocksPostTransfert($metier_mvt_web_connect_transfert_creation, string $contentType = self::contentTypes['stocksPostTransfert'][0])
    {
        list($response) = $this->stocksPostTransfertWithHttpInfo($metier_mvt_web_connect_transfert_creation, $contentType);
        return $response;
    }

    /**
     * Operation stocksPostTransfertWithHttpInfo
     *
     * Créer un mouvement de stock en deux magasins
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation $metier_mvt_web_connect_transfert_creation Description du transfert de marchandise  (transfert) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostTransfert'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksPostTransfertWithHttpInfo($metier_mvt_web_connect_transfert_creation, string $contentType = self::contentTypes['stocksPostTransfert'][0])
    {
        $request = $this->stocksPostTransfertRequest($metier_mvt_web_connect_transfert_creation, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksPostTransfertAsync
     *
     * Créer un mouvement de stock en deux magasins
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation $metier_mvt_web_connect_transfert_creation Description du transfert de marchandise  (transfert) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostTransfertAsync($metier_mvt_web_connect_transfert_creation, string $contentType = self::contentTypes['stocksPostTransfert'][0])
    {
        return $this->stocksPostTransfertAsyncWithHttpInfo($metier_mvt_web_connect_transfert_creation, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksPostTransfertAsyncWithHttpInfo
     *
     * Créer un mouvement de stock en deux magasins
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation $metier_mvt_web_connect_transfert_creation Description du transfert de marchandise  (transfert) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostTransfertAsyncWithHttpInfo($metier_mvt_web_connect_transfert_creation, string $contentType = self::contentTypes['stocksPostTransfert'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert';
        $request = $this->stocksPostTransfertRequest($metier_mvt_web_connect_transfert_creation, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksPostTransfert'
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation $metier_mvt_web_connect_transfert_creation Description du transfert de marchandise  (transfert) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostTransfert'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksPostTransfertRequest($metier_mvt_web_connect_transfert_creation, string $contentType = self::contentTypes['stocksPostTransfert'][0])
    {

        // verify the required parameter 'metier_mvt_web_connect_transfert_creation' is set
        if ($metier_mvt_web_connect_transfert_creation === null || (is_array($metier_mvt_web_connect_transfert_creation) && count($metier_mvt_web_connect_transfert_creation) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $metier_mvt_web_connect_transfert_creation when calling stocksPostTransfert'
            );
        }


        $resourcePath = '/Stocks/Transfert';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($metier_mvt_web_connect_transfert_creation)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($metier_mvt_web_connect_transfert_creation));
            } else {
                $httpBody = $metier_mvt_web_connect_transfert_creation;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation stocksPostVenteEnGros
     *
     * Créer d&#39;une vente en gros
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation $metier_mvt_web_connect_vente_en_gros_creation Description du transfert de marchandise  (venteEnGros) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostVenteEnGros'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros
     */
    public function stocksPostVenteEnGros($metier_mvt_web_connect_vente_en_gros_creation, string $contentType = self::contentTypes['stocksPostVenteEnGros'][0])
    {
        list($response) = $this->stocksPostVenteEnGrosWithHttpInfo($metier_mvt_web_connect_vente_en_gros_creation, $contentType);
        return $response;
    }

    /**
     * Operation stocksPostVenteEnGrosWithHttpInfo
     *
     * Créer d&#39;une vente en gros
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation $metier_mvt_web_connect_vente_en_gros_creation Description du transfert de marchandise  (venteEnGros) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostVenteEnGros'] to see the possible values for this operation
     *
     * @throws \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\ApiException on non-2xx response or if the response body is not in the expected format
     * @throws \InvalidArgumentException
     * @return array of \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros, HTTP status code, HTTP response headers (array of strings)
     */
    public function stocksPostVenteEnGrosWithHttpInfo($metier_mvt_web_connect_vente_en_gros_creation, string $contentType = self::contentTypes['stocksPostVenteEnGros'][0])
    {
        $request = $this->stocksPostVenteEnGrosRequest($metier_mvt_web_connect_vente_en_gros_creation, $contentType);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros' !== 'string') {
                            try {
                                $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                            } catch (\JsonException $exception) {
                                throw new ApiException(
                                    sprintf(
                                        'Error JSON decoding server response (%s)',
                                        $request->getUri()
                                    ),
                                    $statusCode,
                                    $response->getHeaders(),
                                    $content
                                );
                            }
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    try {
                        $content = json_decode($content, false, 512, JSON_THROW_ON_ERROR);
                    } catch (\JsonException $exception) {
                        throw new ApiException(
                            sprintf(
                                'Error JSON decoding server response (%s)',
                                $request->getUri()
                            ),
                            $statusCode,
                            $response->getHeaders(),
                            $content
                        );
                    }
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation stocksPostVenteEnGrosAsync
     *
     * Créer d&#39;une vente en gros
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation $metier_mvt_web_connect_vente_en_gros_creation Description du transfert de marchandise  (venteEnGros) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostVenteEnGrosAsync($metier_mvt_web_connect_vente_en_gros_creation, string $contentType = self::contentTypes['stocksPostVenteEnGros'][0])
    {
        return $this->stocksPostVenteEnGrosAsyncWithHttpInfo($metier_mvt_web_connect_vente_en_gros_creation, $contentType)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation stocksPostVenteEnGrosAsyncWithHttpInfo
     *
     * Créer d&#39;une vente en gros
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation $metier_mvt_web_connect_vente_en_gros_creation Description du transfert de marchandise  (venteEnGros) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function stocksPostVenteEnGrosAsyncWithHttpInfo($metier_mvt_web_connect_vente_en_gros_creation, string $contentType = self::contentTypes['stocksPostVenteEnGros'][0])
    {
        $returnType = '\PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros';
        $request = $this->stocksPostVenteEnGrosRequest($metier_mvt_web_connect_vente_en_gros_creation, $contentType);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'stocksPostVenteEnGros'
     *
     * @param  \PrestaShop\Module\PolarisPrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation $metier_mvt_web_connect_vente_en_gros_creation Description du transfert de marchandise  (venteEnGros) (required)
     * @param  string $contentType The value for the Content-Type header. Check self::contentTypes['stocksPostVenteEnGros'] to see the possible values for this operation
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function stocksPostVenteEnGrosRequest($metier_mvt_web_connect_vente_en_gros_creation, string $contentType = self::contentTypes['stocksPostVenteEnGros'][0])
    {

        // verify the required parameter 'metier_mvt_web_connect_vente_en_gros_creation' is set
        if ($metier_mvt_web_connect_vente_en_gros_creation === null || (is_array($metier_mvt_web_connect_vente_en_gros_creation) && count($metier_mvt_web_connect_vente_en_gros_creation) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $metier_mvt_web_connect_vente_en_gros_creation when calling stocksPostVenteEnGros'
            );
        }


        $resourcePath = '/Stocks/VenteEnGros';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        $headers = $this->headerSelector->selectHeaders(
            ['application/json', ],
            $contentType,
            $multipart
        );

        // for model (json/xml)
        if (isset($metier_mvt_web_connect_vente_en_gros_creation)) {
            if (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the body
                $httpBody = \GuzzleHttp\Utils::jsonEncode(ObjectSerializer::sanitizeForSerialization($metier_mvt_web_connect_vente_en_gros_creation));
            } else {
                $httpBody = $metier_mvt_web_connect_vente_en_gros_creation;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif (stripos($headers['Content-Type'], 'application/json') !== false) {
                # if Content-Type contains "application/json", json_encode the form parameters
                $httpBody = \GuzzleHttp\Utils::jsonEncode($formParams);
            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-Key');
        if ($apiKey !== null) {
            $headers['X-API-Key'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
